/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	title: HELP BROWSER
	filename: l_help.c

	.hypertext browser
	.scrolling effect UP & DOWN

	LEFT		-move next hypertext
	RIGHT		-move prev hypertext
	UP			-scroll up
	DOWN		-scroll down
	ESC			-quit help
	ENTER		-goto selected hypertext
	ALT-F1 	-go back to previous page

	This text is best viewed with TAB set to 2:

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <io.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <user\scankey.h>
#include <user\qwrite.h>
#include <user\help.h>
#include <user\xstring.h>

#define MAX_CHAR 	80
#define STACK			100
#define BUFF_SIZE 2048



/****************************************************
*** main function
*****************************************************/
int helpbrowser(char *label, char *file)
{
struct helppage ht={0};
FILE *fp;           /* file pointer 				*/
byte *buffer;				/* file buffer 					*/
word buffer_size;   /* file buffer size 		*/
int success;				/* flag 								*/
int winh;						/* window handle 				*/

	if((fp=fopen(file,"rt"))==NULL) return 0;		/* check file */

  if(filelength(fileno(fp))>BUFF_SIZE) buffer_size=BUFF_SIZE;
		else buffer_size=filelength(fileno(fp));

	buffer=calloc(1,buffer_size);
  setvbuf(fp,buffer,_IOFBF,buffer_size);

	if(label[0]=='\x0') label="Index";

	ht.prev_selection[0]=0;

	/* initialising stacks **************************/

			ht.stack[ht.nstack]=calloc(1,strlen(label)+1);
			strcpy(ht.stack[ht.nstack],label);
	 	 	ht.nstack++;

  /* end of initialising stack ********************/

	winh=win_center(60,15,DBL_FRAME," Help ",set_color(RED,LIGHTGRAY),set_color(BLACK,LIGHTGRAY));

  /* main loop */
	do{
		if((success=hptf_open(fp,label,&ht))!=0)	{
			strcpy(label,hptf_show(&ht));
			hptf_close(&ht);
		}
	}while(label[0]!='\x0' && success);

	/* freeing stacks */
		ht.nstack--;
		for(;ht.nstack>=0;ht.nstack--)
			free(ht.stack[ht.nstack]);
	/* end of freeing stack */

	/* clearing all reserved memory allocation */
	free(buffer);
	win_delete(winh);
	fclose(fp);
	return 0;
}

/********************************************
*** 	set help memory
***		set help structure
********************************************/
int hptf_open(FILE *fp, char *label, struct helppage *ht)
{
int ret_code=0;												/* return code */
char buffer[MAX_CHAR]={0};						/* temporary buffer */
register int i;												/* counter */

	ht->nlabel=0;												/* initialise number of labels */
  ht->nline=0;												/* initialise number of line */
  rewind(fp);													/* rewind to top of file pointer */

	do{																									/* main loop */
		fgets(buffer,MAX_CHAR,fp);												/* get string */
		if(*buffer=='#'){																  /* label lines found */
			buffer[strlen(buffer)-1]='\x0';									/* clear '\n' */
      trim_right(buffer);                         		/* trim the label */

			if(stricmp(buffer+1,label)==0){							/* requested label found */
				ret_code=1;																/* label found in file   */
				fscanf(fp,"%d\n",&(ht->nlabel));					/* get number of label   */

				for(i=0;i<ht->nlabel;i++){
					fgets(buffer,256,fp);														/* get string */
					buffer[strlen(buffer)-1]='\x0';									/* clear '\n' */
        	ht->label[i]=calloc(1,strlen(buffer));          /* build links */
					strcpy(ht->label[i],buffer+1);
				}

        ht->nline=0;
				fgets(buffer,MAX_CHAR,fp);                         /* build page */

				while(*buffer==';' && !feof(fp)){
          ht->page_buffer[ht->nline]=calloc(1,strlen(buffer)+1);
					strcpy(ht->page_buffer[ht->nline],buffer+1);
					ht->page_buffer[ht->nline][strlen(ht->page_buffer[ht->nline])-1]='\x0';
					ht->nline++;	fgets(buffer,256,fp);

				}														/* end of importing line string */
			}															/* end of label found */
		}																/* end of if buffer[0] equals '#' */
	}while(!feof(fp));								/* end of main loop */
	return ret_code;
}

/**************************************
*** clear memory usage
***************************************/
int hptf_close(struct helppage* ht)
{
register int i;

	for(i=0;i<ht->nlabel;i++){
		free(ht->label[i]);
		ht->label[i]=NULL;
	}

	for(i=0;i<ht->nline;i++){
		free(ht->page_buffer[i]);
		ht->page_buffer[i]=NULL;
	}
	return 1;
}

/********************************************************
*** show text & return label requested else return -1
********************************************************/
char* hptf_show(struct helppage *ht)
{
extern struct screen_structure scr;
extern struct window_structure w[];
char *return_code;  /* label selected */
char ch; word ext; 	/* scankey variables */
int i,j;						/* counters */
int height;					/* height of window */
int top=0;					/* top of list */
int y;							/* y coordinates */
int label=0;				/* active label */
int disp;						/* displacement of hypertext from left */

  label=ht->prev_selection[ht->nstack];		/* goto previous selection */
	cursor(NO_CURSOR);
	height=scr.bottom-scr.top+1;

	scr.normal=set_color(BLACK,LIGHTGRAY);
	scr.inverse=set_color(BLUE,LIGHTGRAY);

  for(;;){														/* main loop */

    /* conditions for scrolling top-bottom */
		if (label<0) label=ht->nlabel-1;
			else if (label>ht->nlabel-1) label=0;

		if (top<0) top=0;

		if(height<ht->nline){
			if(top>ht->nline-height) top=ht->nline-height;
		}
			else if(height>ht->nline) top=0;

	 		alt_screen(ON);												/* active alternate screen */
		  cls();																/* clear current screen */
			for(i=top,y=0;i<top+height;i++){      /* drawing screen */
				if(y==ht->nline) break;
				print(1,y+1,ht->page_buffer[i]);
	        for(j=0;j<ht->nlabel;j++){
						disp=strdisp(ht->page_buffer[i],ht->label[j]);
	      		if(disp!=-1){
	            if(j==label) scr.current=set_color(WHITE,BLACK);
							else scr.current=scr.inverse;
							print(disp,y+1,ht->label[j]);
							scr.current=scr.normal;
						}
					}
				y++;
			}																			/* end of drawing screen 		 */
			alt_screen(OFF);											/* deactive alternate screen */

			scan_key(&ch,&ext);										/* wait for key pressed */

			if (ext==ENTER){
				if(ht->nstack<STACK && ht->label[0][0]!='\x0'){
					ht->stack[ht->nstack]=calloc(1,strlen(ht->label[label])+5);
					strcpy(ht->stack[ht->nstack],ht->label[label]);
					ht->prev_selection[ht->nstack]=label;
					ht->nstack++;
					return_code=ht->label[label];
					break;
				}
			}
				else if (ext==ALT_F1) {
					if(ht->nstack!=1){
						ht->nstack--;
						free(ht->stack[ht->nstack]);
						ht->prev_selection[ht->nstack+1]=0x0;
						return_code=ht->stack[ht->nstack-1];
						break;
					}
				}
				else if (ext==ESC){
					return_code=NULL;
					break;
				}

				switch (ext){
					case DOWN: 	top++;		break;
					case UP: 		top--;		break;
					case RIGHT:	label++;	break;
					case LEFT: 	label--;	break;
				}
	}																				/* end of main loop */
	return return_code;
}